using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Net.Mime;
using System.Net.Sockets;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;

namespace Harjotustyo;

/// @author Omanimi
/// @version 17.11.2023
/// <summary>
/// 
/// </summary>
public class Harjotustyo : PhysicsGame
{
    int PelaajanTerveys = 3;
    
    public override void Begin()
    {
        Alkuvalikko();
        
        
        
        
        PhysicsObject pelaaja = new PhysicsObject(40, 20);
        pelaaja.Shape = Shape.Rectangle;
        Add(pelaaja);
        pelaaja.MaxVelocity = 500;
        pelaaja.Restitution = 0.5;
        pelaaja.MomentOfInertia = 200;
        pelaaja.MaxAngularVelocity = 50;
        


        Vector sijainti = new Vector(RandomGen.NextDouble(5.0, 120.0), RandomGen.NextDouble(5.0, 120.0));
        LuoVihollinen(sijainti);
        
        
        AddCollisionHandler(pelaaja, "seina", PelaajaTormaaSeinaan);
        
        Camera.Follow(pelaaja);
        
        
        Keyboard.Listen(Key.Left, ButtonState.Down, KaannaPelaajaav, "Käänny vasemmalle", pelaaja);
        Keyboard.Listen(Key.Left, ButtonState.Released, pysayta, null, pelaaja);
        Keyboard.Listen(Key.Right, ButtonState.Down, KaannaPelaajaao, "Käänny oikealle", pelaaja);
        Keyboard.Listen(Key.Right, ButtonState.Released, pysayta, null, pelaaja);
        Keyboard.Listen(Key.Up, ButtonState.Down, LiikutaPelaajaaE, "Eteen", pelaaja);
        Keyboard.Listen(Key.Up, ButtonState.Released, Hidasta, null, pelaaja);
        Keyboard.Listen(Key.Down, ButtonState.Down, LiikutaPelaajaaT, "Taakse", pelaaja);
        Keyboard.Listen(Key.Down, ButtonState.Released, Hidasta, null, pelaaja);
        
        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
    }

    /// <summary>
    /// Pelaajan ominaisuuksiin ja komentoihin liittyvää tavaraa
    /// </summary>
    /// <param name="suunta"></param>
    /// <param name="pelaaja"></param>

    

    public void PelaajaTormaaSeinaan(PhysicsObject pelaaja, PhysicsObject seina)
    {
        if (pelaaja.Velocity.Magnitude => 300)
        {
            PelaajanTerveys--;
            if (PelaajanTerveys == 0)
            {
                PeliPaattyy();
            }
        }
    }

    public void PelaajaTormaaVihuun()
    {
        
    }

    public void PeliPaattyy()
    {
        
    }
    
    public void LiikutaPelaajaaE(PhysicsObject pelaaja)
    {
        Vector pelaajanSuunta = Vector.FromLengthAndAngle(1000.0, pelaaja.Angle);
        pelaaja.Push(pelaajanSuunta);
    }
    
    public void LiikutaPelaajaaT(PhysicsObject pelaaja)
    {
        Vector pelaajanSuunta = Vector.FromLengthAndAngle(-1000.0, pelaaja.Angle);
        pelaaja.Push(pelaajanSuunta);
    }

    public void KaannaPelaajaav(PhysicsObject pelaaja)
    {
        pelaaja.ApplyTorque(1000);
    }
    
    public void KaannaPelaajaao(PhysicsObject pelaaja)
    {
        pelaaja.ApplyTorque(-1000);
    }

    public void pysayta(PhysicsObject pelaaja)
    { 
        pelaaja.StopAngular();
    }

    public void Hidasta(PhysicsObject pelaaja)
    {
        pelaaja.LinearDamping = 2.50;
    }

    /// <summary>
    /// Kentän ja sen osasten luontia seuraavilla ohjelmilla.
    /// </summary>

    public void Alkuvalikko()
    {
        MultiSelectWindow Alkuvalikko = new MultiSelectWindow("Pelin alkuvalikko", "Aloita peli", "Ennätykset", "Lopeta");
        Alkuvalikko.AddItemHandler(0, AloitaPeli);
        Alkuvalikko.AddItemHandler(1, ParhaatPisteet);
        Alkuvalikko.AddItemHandler(2, Exit);
        Add(Alkuvalikko);
    }

    public void AloitaPeli()
    {
        MultiSelectWindow Kentat = new MultiSelectWindow("Valitse taso", "Taso 1", "Taso 2", "Taso 3", "Yllätä mut", "Palaa");
        Kentat.AddItemHandler(0, LuoTaso1);
        Kentat.AddItemHandler(1, LuoTaso2);
        Kentat.AddItemHandler(2, LuoTaso3);
        
        Add(Kentat);
    }

    public void ParhaatPisteet()
    {
        
    }
    
   public void LuoTaso1()
    {
        TileMap ruudut = TileMap.FromLevelAsset("EkaTaso.txt");
        ruudut.SetTileMethod('#', LuoSeina);
        ruudut.Execute(20, 20);
        Level.CreateBorders();
        LuoAikalaskuri();
        


    }

   public void LuoTaso2()
   {
       TileMap ruudut = TileMap.FromLevelAsset("TokaTaso.txt");
       ruudut.SetTileMethod('#', LuoSeina);
       ruudut.Execute(20, 20);
       Level.CreateBorders();
       LuoAikalaskuri();
       

   }

   public void LuoTaso3()
   {
       
   }
   
    public void LuoSeina(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject seina = PhysicsObject.CreateStaticObject(leveys, korkeus);
        seina.Position = paikka;
        seina.Shape = Shape.Rectangle;
        seina.Color = Color.DarkGray;
        seina.Tag = "seina";
        Add(seina);
    }


    
    /// <summary>
    /// Vihollisiin liittyvää ohjelmointia seuraavissa pätkissä.
    /// </summary>
    /// <param name="sijainti"></param>
    
    void LuoVihollinen(Vector sijainti)
    {
        PhysicsObject vihollinen = new PhysicsObject(20, 40);
        vihollinen.Shape = Shape.Rectangle;
        vihollinen.Color = Color.Red;
        Add(vihollinen);
    }
    
    ///Kaikkee jännää
    ///
    public void LuoAikalaskuri()
    {
        Timer aikalaskuri = new Timer();
        aikalaskuri.Start(); 

        Label aikanaytto = new Label();
        aikanaytto.TextColor = Color.Yellow;
        aikanaytto.DecimalPlaces = 1;
        aikanaytto.BindTo(aikalaskuri.SecondCounter);
        aikanaytto.X = Screen.Right - 20;
        aikanaytto.Y = Screen.Top - 20;
        Add(aikanaytto);
    }
    
}
